<?php
/*
Plugin Name: Experts Exchange EEple Badge
Version: 0.1
Plugin URI: http://wordpress.org/extend/plugins/experts-exchange-eeple-badge/
Description: Widget for Experts Exchange EEple Badge
Author: Theodore J. Salvo
Author URI: http://theodorejsalvo.com/
License: GPL2

    Copyright 2010  Theodore J. Salvo

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function create_eeple_badge($profile)
{
  // Load Page using CURL and Extract Contents  
  $ch = curl_init();
  curl_setopt ($ch, CURLOPT_URL, "http://www.experts-exchange.com/M_$profile.html");
  curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 5);
  $page = curl_exec($ch);
  curl_close($ch);
  
  // Get Variable Data From Page
  preg_match('@<span>([0-9]{1,3}(?:,[0-9]{3})*)</span>\s+Expert Points@', $page, $points);
  preg_match('@<span>([0-9]{2}/[0-9]{2}/[0-9]{2,4})</span>\s+Registration Date@', $page, $date);
  preg_match('@<span>([[:alnum:]]+)</span>(\s+Login Name)@', str_replace('<wbr />', '', $page), $name);
  preg_match('@<div.*eepleBox.*div>\n@', $page, $line);
  
  //Calculate Points
  $points_temp = (int)str_replace(",","",$points[1]);
      if($points_temp <     50000) { $RankTitle = "Rookie";     $RankLevel = "00"; }
  elseif($points_temp <    150000) { $RankTitle = "Master";     $RankLevel = "01"; }
  elseif($points_temp <    300000) { $RankTitle = "Guru";       $RankLevel = "02"; }
  elseif($points_temp <    500000) { $RankTitle = "Wizard";     $RankLevel = "03"; }
  elseif($points_temp <   1000000) { $RankTitle = "Sage";       $RankLevel = "04"; }
  elseif($points_temp <  10000000) { $RankTitle = "Genius";     $RankLevel = "05"; }
  elseif($points_temp <  25000000) { $RankTitle = "Savant";     $RankLevel = "06"; }
  elseif($points_temp <  50000000) { $RankTitle = "Elite";      $RankLevel = "07"; }
  elseif($points_temp < 100000000) { $RankTitle = "Technocrat"; $RankLevel = "08"; }
  else                             { $RankTitle = "Legend";     $RankLevel = "09"; }
  $RankURL = ($RankLevel == "00") ? "Man_Sign04" : "Man_Rank" . $RankLevel;
  
  // Path to EEple Images
  $preURL  = "http://images.experts-exchange.com/xp/images/EEples/";
  $postURL = ".png";
  
  // Gender
  preg_match('@eepleBox\s(\w?\w?man)@', $line[0], $gender);
  $gender = $gender[1];
  
  // Shadow
  $ShadowURL = ucfirst($gender) . "_Shadow"; 
  
  // Body Skin Tone
  preg_match('@manBodySkinTone(\d\d)@', $line[0], $BodySkinTone);
  $BodySkinToneURL = ucfirst($gender) . "_BodySkinTone" . $BodySkinTone[1];
  if($gender == "woman") $BodySkinToneURL .= "_b";
  
  // Skin Tone
  preg_match('@manSkinTone(\d\d)@', $line[0], $SkinTone);
  $SkinToneURL = ucfirst($gender) . "_SkinTone" . $SkinTone[1];
  
  // Shirt
  preg_match('@manShirt(\d\d)(\w*)@', $line[0], $Shirt);
  $shirt_temp[0] = str_replace('manShirt','', $shirt_temp[0]);
  $ShirtStyle = $Shirt[1];
  $ShirtColor = $Shirt[2]; 
  if($gender == "man")
  {
    if($ShirtStyle == "01") $ShirtStyle = "02";
    else if($ShirtStyle == "02") $ShirtStyle = "01";
    $ShirtURL = ucfirst($gender) . "_Shirt" . $ShirtStyle . "_" . $ShirtColor;
  }
  else
  {
    if($ShirtStyle == "01" || $ShirtStyle == "02")
      $ShirtURL = ucfirst($gender) . "_Shirt" . $ShirtStyle . "_" . $ShirtColor;
    if($ShirtStyle == "03")
      $ShirtURL = ucfirst($gender) . "_Hoodie01_" . $ShirtColor;
    if($ShirtStyle == "04")
      $ShirtURL = ucfirst($gender) . "_Shirt03_" . $ShirtColor . "_b";
  }
  
  // Haircut
  preg_match('@manHaircut(\d\d)(\w*)@', $line[0], $Haircut);
  $HaircutStyle = $Haircut[1];
  $HaircutColor = $Haircut[2];
  $HaircutURL = ucfirst($gender) . "_Haircut" . $HaircutStyle;
  if($gender == "woman") $HaircutURL .= "_";
  $HaircutURL .= $HaircutColor;
  
  // Facial Hair
  preg_match('@\w?\w?[fF]acialHair(\d?\d?)(\w*)@', $line[0], $fh_temp);
  if($gender == "woman" || substr($fh_temp[0], 0, 2) == "no")
  {
    $NoFacialHair = "true";
    $FacialHairStyle = "";
    $FacialHairColor = "";
  }
  else
  {
    $NoFacialHair = "false";
    $FacialHairStyle = $fh_temp[1];
    $FacialHairColor = $fh_temp[2];
    if($FacialHairStyle == "01" || $FacialHairStyle == "02")
      $FacialHairURL = "Man_Beard" . $FacialHairStyle . "_" . $FacialHairColor;
    else
      $FacialHairURL = "Man_Moustache01_" . $FacialHairColor;  
  }

  print("\n<div id=\"eeple-badge-container\" onclick=\"window.open('http://www.experts-exchange.com/M_$profile.html')\">\n");
  print("  <div id=\"eeple\">\n");
  print("    <div><img src=\"$preURL$ShadowURL$postURL\" /></div>\n");
  print("    <div><img src=\"$preURL$BodySkinToneURL$postURL\" /></div>\n");
  print("    <div><img src=\"$preURL$SkinToneURL$postURL\" /></div>\n");
  print("    <div><img src=\"$preURL$ShirtURL$postURL\" /></div>\n");
  print("    <div><img src=\"$preURL$HaircutURL$postURL\" /></div>\n");
  if($gender == "man" && $NoFacialHair == "false")
  print("    <div><img src=\"$preURL$FacialHairURL$postURL\" /></div>\n");
  print("    <div><img src=\"$preURL$RankURL$postURL\" /></div>\n");
  print("  </div>\n");
  print("  <div id=\"eeple-name\">$name[1]</div><br />\n");
  print("  <div id=\"eeple-points-rank\">$points[1]<br />$RankTitle</div>\n");
  print("  <div id=\"eeple-member-date\"><span>Member Since<br /></span>$date[1]</div>\n");
  print("</div>\n");

}

function register_css()
{
  $cssUrl = WP_PLUGIN_URL . '/experts-exchange-eeple-badge/eeple-badge.css';
  $cssFile = WP_PLUGIN_DIR . '/experts-exchange-eeple-badge/eeple-badge.css';
  if ( file_exists($cssFile) ) {
    wp_register_style('EEple Badge StyleSheet', $cssUrl);
    wp_enqueue_style( 'EEple Badge StyleSheet');
  }
}

function widget_eeplebadge_init() {
	if (!function_exists('register_sidebar_widget')) {
		return;
	}
	
  function widget_eeplebadge($args) {
    extract($args);
    echo $before_widget . $before_title . 'Experts Exchange' . $after_title;
    $profile = get_option('widget_eeplebadge');
    create_eeple_badge($profile[0]);
    echo $after_widget;
  }
  
  function widget_eeplebadge_options()
  {
  	$profile = get_option('widget_eeplebadge');
  	$profile = $profile[0];
  	if($_POST['eeplebadge-submit'])
  	{
  		if(ereg('[0-9]{4,7}',$_POST['eeplebadge-profile']))
  		{
  			update_option('widget_eeplebadge', array($_POST['eeplebadge-profile']));
  			$profile = $_POST['eeplebadge-profile'];
  		}
  		else
  		{
  			echo "<p style='font-weight:bold;'><span style='color:red'>Invalid link:</span> The profile link provided should be between 4 and 7 digits and may only contain numbers. Please enter a valid code</p>";
  		}
  	}
  	echo '<p>Complete the link to your EE profile:<br>http://www.experts-exchange.com/M_<input type="text" name="eeplebadge-profile" value="'.$profile.'" id="eeplebadge-profile" />.html'."\n";
  	echo '<input type="hidden" id="eeplebadge-submit" name="eeplebadge-submit" value="1" />'."\n";
  }

  wp_register_sidebar_widget('eeple-badge','EEple Badge','widget_eeplebadge');
  register_widget_control('EEple Badge','widget_eeplebadge_options', 500, 50);
}

add_action('wp_print_styles', 'register_css');
add_action('plugins_loaded', 'widget_eeplebadge_init');

?>